package com.me.pacman.entity;

import com.badlogic.gdx.math.Vector2;

public enum Direction {

    UP(new Vector2(0f, 1f)),
    DOWN(new Vector2(0f, -1f)),
    LEFT(new Vector2(-1f, 0f)),
    RIGHT(new Vector2(1f, 0f)),
    ;

    private Vector2 vector;

    Direction(Vector2 vector) {
        this.vector = vector;
    }

    public Direction getOpposite() {
        switch (this) {
            case UP:
                return DOWN;
            case DOWN:
                return UP;
            case LEFT:
                return RIGHT;
            case RIGHT:
                return LEFT;
        }
        return null;
    }

    public boolean isOpposite(Direction dir) {
        return dir == getOpposite();
    }

    public Vector2 getVector(float scale) {
        return new Vector2(this.vector).scl(scale);
    }

    public Vector2 getVector() {
        return this.getVector(1f);
    }

    public static Direction fromVector(Vector2 vector) {
        for (Direction dir : values()) {
            if (dir.vector.hasSameDirection(vector)) {
                return dir;
            }
        }
        return null;
    }

}
