package com.me.pacman.entity.ai;

import com.badlogic.gdx.math.Vector2;
import com.me.pacman.state.PlayState;

public class InkyChaseBehaviour extends Behaviour {

    public InkyChaseBehaviour(PlayState state) {
        super(state);
    }

    @Override
    public Target getTarget() {
        Vector2 twoAheadPacman = state.pacman.currDirection.getVector(2).add(state.pacman.getTileVector());
        Vector2 blinkyTile = state.ghosts[0].getTileVector();
        float dst = twoAheadPacman.dst(blinkyTile);         // distance between Blinky + pacman
        Vector2 dir = twoAheadPacman.sub(blinkyTile);       // direction from blink to pacman tile
        return new Target(blinkyTile.add(dir.scl(dst * 2)));
    }
}
