package com.me.pacman.level;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.files.FileHandle;

public class LevelLoader {

    private FileHandle levelFile;

    public LevelLoader(String level) {
        levelFile = Gdx.files.internal("data/" + level + ".txt");
    }

    public LevelTile[][] loadLevel() {
        String levelData = levelFile.readString();
        String[] lines = levelData.split("\n");
        int rows = lines.length;
        LevelTile[][] components = new LevelTile[rows][lines[0].length()];

        for (int i = 0; i < rows; i++) {
            String line = lines[i];
            for (int j = 0; j < line.length(); j++) {
                char c = line.charAt(j);

                int row = rows - i - 1;
                switch(c) {
                    case '*':
                        components[row][j] = LevelTile.PELLET;
                        break;
                    case '%':
                        components[row][j] = LevelTile.POWER_PELLET;
                        break;
                    case '#':
                        components[row][j] = LevelTile.WALL;
                        break;
                    case '^':
                        components[row][j] = LevelTile.GHOST_CHAMBER;
                        break;
                    case '_':
                        components[row][j] = LevelTile.GHOST_GATE;
                        break;
                    case '-':
                        components[row][j] = LevelTile.TUNNEL;
                        break;
                    default:
                        components[row][j] = LevelTile.EMPTY;
                }
            }
        }

        return components;
    }

}
